package net.maunium.bukkit.InfoSigns;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import net.maunium.bukkit.InfoSigns.Commands.InfoCreate;
import net.maunium.bukkit.InfoSigns.Commands.InfoInspect;
import net.maunium.bukkit.InfoSigns.Commands.InfoModify;
import net.maunium.bukkit.InfoSigns.Commands.InfoRemove;
import net.maunium.bukkit.InfoSigns.Listeners.BlockPlaceListener;
import net.maunium.bukkit.InfoSigns.Listeners.SignChangeListener;
import net.maunium.bukkit.InfoSigns.Listeners.UseListener;
import net.maunium.bukkit.InfoSigns.Misc.InfoTag;

import org.bukkit.plugin.java.JavaPlugin;

public class InfoSigns extends JavaPlugin {
	
	public Map<String, InfoTag> infotags;
	public String errtag, stag;
	
	@Override
	public void onEnable() {
		errtag = "4l[InfoSigns]c ";
		stag = "2l[InfoSigns]f ";
		//Log start time.
		long startTime = System.currentTimeMillis();
		/*
		 * Konfiguraation lukeminen.
		 */
		this.saveDefaultConfig();
		Map<String, Object> itt = getConfig().getConfigurationSection("TagText").getValues(true);
		infotags = new HashMap<String, InfoTag>();
		for(Entry<String, Object> e : itt.entrySet()){
			String[] tntemp = e.getKey().split("-");
			String tagname = tntemp[1];
			InfoTag tag = new InfoTag(tntemp[0]);
			
			if(e.getValue() instanceof List<?>){
				List<?> text = ((List<?>) e.getValue());
				int i = 1;
				for(Object o : text){
					tag.setText(i, o + "");
					i++;
				}
			} else {
				getLogger().severe("Uhm... Something went wrong... Try resetting the configuration :)");
			}
			infotags.put(tagname, tag);
		}
		/*
		 * Komentoajurien asettaminen.
		 */
		this.getCommand("infocreate").setExecutor(new InfoCreate(this));
		this.getCommand("inforemove").setExecutor(new InfoRemove(this));
		this.getCommand("infomodify").setExecutor(new InfoModify(this));
		this.getCommand("infoinspect").setExecutor(new InfoInspect(this));
		/*
		 * EventHandlerien rekisteriminen
		 */
		getServer().getPluginManager().registerEvents(new UseListener(this), this);
		getServer().getPluginManager().registerEvents(new SignChangeListener(this), this);
		getServer().getPluginManager().registerEvents(new BlockPlaceListener(), this);
		//Log end time
		long endTime = System.currentTimeMillis();
		//Calculate load time
		int loadTime = (int) (endTime - startTime);
		//Load time printout
		getLogger().info("InfoSigns 0.2 by Tulir293 Enabled in " + loadTime + "ms.");
	}

	@Override
	public void onDisable() {
		long startTime = System.currentTimeMillis();
		long endTime = System.currentTimeMillis();
		for(Entry<String, InfoTag> e : infotags.entrySet()){
			List<String> list = new ArrayList<String>();
			for(String s : e.getValue().getLines()){
				if(s != null && s != "null"){
					list.add(s);
				}
			}
			this.getConfig().set("TagText." + e.getValue().getOwner() + "-" + e.getKey(), list);
		}
		this.saveConfig();
		int unloadTime = (int) (endTime - startTime);
		getLogger().info("InfoSigns 0.2 by Tulir293 Disabled in " + unloadTime + "ms.");
	}
	public void createTag(String name, String player){
		infotags.put(name, new InfoTag(player));
	}
	public void setTagText(String tagname, int row, String text){
		InfoTag temp = infotags.get(tagname);
		temp.setText(row, text);
		infotags.put(tagname, temp);
	}
}
