package net.maunium.bukkit.InfoSigns.Misc;

public class InfoTag {
	private String owner;
	private String[] text;
	/**
	 * Create an InfoTag with no text
	 * @param owner The owner of the InfoTag
	 */
	public InfoTag(String owner) {
		this.owner = owner;
		text = new String[10];
		text[0] = "This InfoTag has no text.";
	}
	/**
	 * Modify a row.
	 * @param row Modify the X:st/nd/rd/th row.
	 * @param text The text to insert into the row.
	 */
	public void setText(int row, String text) {
		if(row < 1){
			row = 1;
		}
		if(row > 10){
			row = 10;
		}
		this.text[row - 1] = text;
	}
	/**
	 * Set the owner of the InfoTag.
	 * @param p 
	 */
	public void setOwner(String p) {
		this.owner = p;
	}
	/**
	 * @return Owner of the InfoTag.
	 */
	public String getOwner() {
		return owner;
	}
	/**
	 * @param row The row to get the text of.
	 * @return Text in the row %PARAM_ROW%
	 */
	public String getText(int row) {
		if(row < 1){
			row = 1;
		}
		if(row > 10){
			row = 10;
		}
		return text[row - 1];
	}
	public String[] getLines(){
		return text;
	}
}
