package net.maunium.bukkit.Mau1v1;

import java.util.UUID;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;

import net.maunium.bukkit.Maussentials.Utils.MetadataUtils;

public class HitListener implements Listener {
	private Mau1v1 plugin;
	public static final String CHALLENGE_TO = "Mau1v1HasChallenged";
	
	public HitListener(Mau1v1 plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler
	public void onInteract(EntityDamageByEntityEvent evt) {
		if (evt.getEntity() instanceof Player && evt.getDamager() instanceof Player) {
			Player t = (Player) evt.getEntity();
			Player a = (Player) evt.getDamager();
			
			if (t.getItemInHand().equals(plugin.getChallengeItem()) && a.getItemInHand().equals(plugin.getChallengeItem())) {
				t.sendMessage(plugin.translate("challenge.receive", a.getName()));
				
				if (a.hasMetadata(CHALLENGE_TO)) {
					UUID u = (UUID) MetadataUtils.getMetadata(a, CHALLENGE_TO, plugin).value();
					Player p = plugin.getServer().getPlayer(u);
					if (p != null && p.isOnline()) {
						p.sendMessage(plugin.translate("challenge.receive.cancelled", a.getName()));
						a.sendMessage(plugin.translate("challenge.send.replaced", t.getName(), p.getName()));
					}
				} else a.sendMessage(plugin.translate("challenge.send", t.getName()));
				MetadataUtils.setFixedMetadata(a, CHALLENGE_TO, t.getUniqueId(), plugin);
			}
		}
	}
}
