package net.maunium.bukkit.MauBans.CommandExecutors;

import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

import net.maunium.bukkit.MauBans.Ban;
import net.maunium.bukkit.MauBans.MauBans;
import net.maunium.bukkit.MauBukLib.MauUtils;

public class CommandMute implements CommandExecutor {
	private MauBans plugin;
	
	public CommandMute(MauBans plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (args.length == 1 || args.length == 2) {
			sender.sendMessage(plugin.errtag + plugin.format("error.mutebanreason"));
			return true;
		} else if (args.length > 2) {
			OfflinePlayer p = MauUtils.getOfflinePlayer(args[0]);
			if(p == null){
				sender.sendMessage(plugin.errtag + plugin.format("error.nevervisited", args[0]));
				return true;
			}
			long mutetime = -1;
			String time = args[1];
			if (time.endsWith("ms")) mutetime = Long.parseLong(time.substring(0, time.length() - 2));
			else if (time.endsWith("s")) mutetime = Long.parseLong(time.substring(0, time.length() - 1)) * 1000;
			else if (time.endsWith("m")) mutetime = Long.parseLong(time.substring(0, time.length() - 1)) * 1000 * 60;
			else if (time.endsWith("h")) mutetime = Long.parseLong(time.substring(0, time.length() - 1)) * 1000 * 60 * 60;
			else if (time.endsWith("d")) mutetime = Long.parseLong(time.substring(0, time.length() - 1)) * 1000 * 60 * 60 * 24;
			else if (time.endsWith("W")) mutetime = Long.parseLong(time.substring(0, time.length() - 1)) * 1000 * 60 * 60 * 24 * 7;
			else if (time.endsWith("M")) mutetime = Long.parseLong(time.substring(0, time.length() - 1)) * 1000 * 60 * 60 * 24 * 30;
			else if (time.endsWith("Y")) mutetime = Long.parseLong(time.substring(0, time.length() - 1)) * 1000 * 60 * 60 * 24 * 365;
			else {
				sender.sendMessage(plugin.errtag + plugin.format("error.time"));
				return true;
			}
			StringBuffer sb = new StringBuffer();
			for (int i = 2; i < args.length; i++) {
				sb.append(args[i]);
				sb.append(" ");
			}
			sb.deleteCharAt(sb.length() - 1);
			String reason = sb.toString();
			plugin.mute(p.getUniqueId(), sender.getName(), reason, System.currentTimeMillis() + mutetime + 500);

			boolean silent = plugin.v.isVanished(sender);
			if(reason.endsWith(" silent")){
				reason = reason.substring(reason.length() - 7, reason.length());
				silent = true;
			}
			
			if(!silent) plugin.getServer().broadcast(plugin.format("broadcast.mute", p.getName(), Ban.getDurationBreakdown(mutetime, 0), reason, sender.getName()), "maubans.see.mute");
			return true;
		}
		return false;
	}
}
