package net.maunium.bukkit.MauBans.CommandExecutors;

import java.util.List;
import java.util.UUID;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.metadata.MetadataValue;

import net.maunium.bukkit.MauBans.Ban;
import net.maunium.bukkit.MauBans.MauBans;
import net.maunium.bukkit.MauBukLib.MauBukLib;
import net.maunium.bukkit.MauBukLib.MauUtils;

public class CommandSeen implements CommandExecutor {
	private MauBans plugin;
	
	public CommandSeen(MauBans plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (args.length == 1) {
			OfflinePlayer op = MauUtils.getOfflinePlayer(args[0]);
			if (op == null && args[0].contains(".")) {
				if (plugin.isIpBanned(args[0])) sender.sendMessage(plugin.stag + plugin.format("seen.message.ban", args[0], plugin.getIpBan(args[0])));
				List<String> names = MauBukLib.getPlayerData().getPlayersByIP(args[0]);
				if (names.isEmpty()) sender.sendMessage(plugin.stag + plugin.format("seen.ipsearch.empty", args[0]));
				else {
					StringBuffer sb = new StringBuffer();
					for (String s : names) {
						sb.append(ChatColor.GOLD + s + ChatColor.GRAY);
						sb.append(", ");
					}
					sb.delete(sb.length() - 2, sb.length());
					sender.sendMessage(plugin.stag + plugin.format("seen.ipsearch.done", args[0], sb.toString()));
				}
			} else if (op != null) {
				UUID uuid = null;
				String ip = null;
				if (op.getUniqueId() == null) {
					List<UUID> list = MauBukLib.getPlayerData().getUUIDsByName(args[0]);
					if (!list.isEmpty()) uuid = list.get(0);
				} else uuid = op.getUniqueId();
				if (op.isOnline()) ip = op.getPlayer().getAddress().getAddress().getHostAddress();
				else if (uuid != null) ip = MauBukLib.getPlayerData().getIPByUUID(uuid);
				
				sender.sendMessage(plugin.stag + plugin.format("seen.message.title", op.getName()));
				
				if (ip != null) sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.ip", ip));
				else sender.sendMessage(ChatColor.RED + plugin.format("seen.message.ip", plugin.format("seen.message.notfound")));
				
				if (uuid != null) {
					sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.uuid", uuid));
					long lastlogin = MauBukLib.getPlayerData().getLastLoginByUUID(uuid);
					if (lastlogin != 0) {
						lastlogin = System.currentTimeMillis() - lastlogin;
						if (op.isOnline()) sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.lastlogin.online", Ban.getDurationBreakdown(lastlogin, 1)));
						else sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.lastlogin.offline", Ban.getDurationBreakdown(lastlogin, 1)));
					}
					Location l = op.isOnline() ? op.getPlayer().getLocation() : MauBukLib.getPlayerData().getLocationByUUID(uuid);
					if (l != null) sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.location", MauUtils.toReadableString(l)));
				} else sender.sendMessage(ChatColor.RED + plugin.format("seen.message.uuid", plugin.format("seen.message.notfound")));
				
				if(op.isOnline()){
					Player p = op.getPlayer();
					if(p.hasMetadata("maucros")){
						MetadataValue mv = p.getMetadata("maucros").get(0);
						sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.maucros", mv.asString()));
					}
				}
				
				if (plugin.isBanned(op.getUniqueId())) {
					Ban b = plugin.getBan(op.getUniqueId());
					sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.ban", op.getName(), b.getReason(), b.getBannedBy()));
					if (!b.isPermanent()) sender.sendMessage(ChatColor.GRAY + plugin.format("seen.message.ban.expires", Ban.getDurationBreakdown(b.getTimeToTimeout(), 0)));
				}
			} else sender.sendMessage(plugin.errtag + plugin.format("error.nevervisited", args[0]));
			return true;
		} else return false;
	}
}