package net.maunium.bukkit.MauBans.CommandExecutors;

import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

import net.maunium.bukkit.MauBans.MauBans;
import net.maunium.bukkit.MauBukLib.MauUtils;

public class CommandUnban implements CommandExecutor {
	private MauBans plugin;
	
	public CommandUnban(MauBans plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (args.length > 0) {
			OfflinePlayer op = MauUtils.getOfflinePlayer(args[0]);
			if (op == null || !plugin.isBanned(op.getUniqueId())) {
				sender.sendMessage(plugin.errtag + args[0] + " is not banned!");
				return true;
			}
			plugin.unban(op.getUniqueId(), op.getName());
			
			boolean silent = plugin.v.isVanished(sender);
			if (args.length > 1 && args[1].equalsIgnoreCase("silent")) silent = true;
			
			if (!silent) plugin.getServer().broadcast(plugin.format("broadcast.unbanned", op.getName(), sender.getName()), "maubans.see.unbanip");
			return true;
		}
		return false;
	}
}