package net.maunium.bukkit.MauBans.CommandExecutors;

import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

import net.maunium.bukkit.MauBans.MauBans;
import net.maunium.bukkit.MauBukLib.MauBukLib;
import net.maunium.bukkit.MauBukLib.MauUtils;

public class CommandUnbanIP implements CommandExecutor {
	private MauBans plugin;
	
	public CommandUnbanIP(MauBans plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (args.length == 1) {
			OfflinePlayer op = MauUtils.getOfflinePlayer(args[0]);
			if (op != null) {
				String ip = MauBukLib.getPlayerData().getIPByUUID(op.getUniqueId());
				plugin.unbanip(ip);
				
				boolean silent = plugin.v.isVanished(sender);
				if (args.length > 1 && args[1].equalsIgnoreCase("silent")) silent = true;
				
				if (!silent) plugin.getServer().broadcast(plugin.format("broadcast.unbanned", ip + plugin.format("ipof", op.getName()), sender.getName()), "maubans.see.unbanip");
				return true;
			} else {
				plugin.unbanip(args[0]);
				
				boolean silent = plugin.v.isVanished(sender);
				if (args.length > 1 && args[1].equalsIgnoreCase("silent")) silent = true;
				
				if (!silent) plugin.getServer().broadcast(plugin.format("broadcast.unbanned", args[0], sender.getName()), "maubans.see.unbanip");
				return true;
			}
		}
		return false;
	}
}