package net.maunium.bukkit.MauBans;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

public class MauVanish implements Listener {
	private MauBans plugin;
	private List<UUID> vanished = new ArrayList<UUID>();
	
	public MauVanish(MauBans plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onPlayerCommand(PlayerCommandPreprocessEvent evt) {
		Player p = evt.getPlayer();
		if (!p.isOp() && !p.hasPermission("mauvanish.use") && !p.hasPermission("*")) return;
		String msg = evt.getMessage().toLowerCase();
		if (msg.startsWith("/mauvanish") || msg.startsWith("/vanish") || msg.startsWith("/mauv") || msg.equals("/v")) {
			evt.setCancelled(true);
			if (this.vanished.contains(p.getUniqueId())) {
				show(p);
				this.vanished.remove(p.getUniqueId());
				
				p.sendMessage(plugin.format("vanish.visible"));
				Bukkit.getServer().broadcastMessage(plugin.getConfig().getString("vanish-join").replace("<player>", p.getName()).replace('&', ChatColor.COLOR_CHAR));
			} else {
				hide(p);
				this.vanished.add(p.getUniqueId());
				
				p.sendMessage(plugin.format("vanish.invisible"));
				Bukkit.getServer().broadcastMessage(plugin.getConfig().getString("vanish-quit").replace("<player>", p.getName()).replace('&', ChatColor.COLOR_CHAR));
			}
		}
	}
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent evt) {
		for (UUID p : this.vanished)
			evt.getPlayer().hidePlayer(plugin.getServer().getPlayer(p));
		show(evt.getPlayer());
	}
	
	@EventHandler
	public void onPlayerLeave(PlayerQuitEvent evt) {
		if (vanished.contains(evt.getPlayer().getUniqueId())) {
			this.vanished.remove(evt.getPlayer().getUniqueId());
			evt.setQuitMessage(null);
			show(evt.getPlayer());
		}
	}
	
	public boolean isVanished(CommandSender cs) {
		if (cs instanceof Player) return vanished.contains(((Player) cs).getUniqueId());
		else return false;
	}
	
	public boolean isVanished(Player p){
		return vanished.contains(p.getUniqueId());
	}
	
	private void show(Player p) {
		p.removePotionEffect(PotionEffectType.INVISIBILITY);
		for (Player pl : Bukkit.getServer().getOnlinePlayers())
			pl.showPlayer(p);
	}
	
	private void hide(Player p) {
		p.addPotionEffect(new PotionEffect(PotionEffectType.INVISIBILITY, 999999999, 1), true);
		for (Player pl : Bukkit.getServer().getOnlinePlayers())
			pl.hidePlayer(p);
	}
}
