package net.maunium.bukkit.MauBukLib;

import java.sql.SQLException;

import org.bukkit.Location;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

public class LoginListener implements Listener {
	private MauBukLib plugin;
	
	public LoginListener(MauBukLib plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onPlayerPreLogin(AsyncPlayerPreLoginEvent evt) {
		if (evt.getAddress() != null && evt.getUniqueId() != null && evt.getName() != null) {
			String ia = evt.getAddress().getHostAddress();
			try {
				MauBukLib.getPlayerData().setEntry(evt.getUniqueId(), evt.getName(), ia, new Location(plugin.getServer().getWorld("world"), 0, 0, 0, 0, 0));
				plugin.getLogger().fine("Updated database. New entry: " + evt.getUniqueId() + ", " + evt.getName() + ", " + ia);
			} catch (SQLException e) {
				plugin.getLogger().severe("Failed attempt to add new entry: " + evt.getUniqueId() + ", " + evt.getName() + ", " + ia);
				e.printStackTrace();
			}
		}
	}
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onPlayerJoin(PlayerJoinEvent evt){
		try {
			MauBukLib.getPlayerData().updateLocation(evt.getPlayer().getUniqueId(), evt.getPlayer().getLocation());
			plugin.getLogger().fine("Updated Location for " + evt.getPlayer().getName());
		} catch (SQLException e) {
			plugin.getLogger().severe("Failed to update Location for " + evt.getPlayer().getName());
			e.printStackTrace();
		}
	}
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onPlayerQuit(PlayerQuitEvent evt) {
		try {
			MauBukLib.getPlayerData().updateTime(evt.getPlayer().getUniqueId());
			plugin.getLogger().fine("Updated LastLogin time for " + evt.getPlayer().getName());
		} catch (SQLException e) {
			plugin.getLogger().severe("Failed to update LastLogin time for " + evt.getPlayer().getName());
			e.printStackTrace();
		}
		try {
			MauBukLib.getPlayerData().updateLocation(evt.getPlayer().getUniqueId(), evt.getPlayer().getLocation());
			plugin.getLogger().fine("Updated Location for " + evt.getPlayer().getName());
		} catch (SQLException e) {
			plugin.getLogger().severe("Failed to update Location for " + evt.getPlayer().getName());
			e.printStackTrace();
		}
	}
}
