package net.maunium.bukkit.MauBukLib;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.plugin.Plugin;

public class PreCommandListener implements Listener {
	@EventHandler(priority = EventPriority.LOW, ignoreCancelled = true)
	public void onPreCommandLate(PlayerCommandPreprocessEvent evt) {
		String msg = evt.getMessage().toLowerCase().substring(1);
		if (msg.startsWith("plugins") || msg.equals("pl") || msg.equals("plug") || msg.equals("plugs") || msg.equals("plugin")) {
			evt.setCancelled(true);
			Player p = evt.getPlayer();
			if (!p.hasPermission("maubuklib.plugins")) {
				p.sendMessage(ChatColor.RED + "You don't have the permission to list the plugins.");
				return;
			}
			List<String> plugins = new ArrayList<String>();
			int emp = 0;
			int dmp = 0;
			int ep = 0;
			int dp = 0;
			for (Plugin pl : Bukkit.getServer().getPluginManager().getPlugins()) {
				if (pl.getDescription().getMain().startsWith("net.maunium") || pl.getName().toLowerCase().contains("mau")) {
					if (pl.isEnabled()) {
						plugins.add(ChatColor.GREEN + pl.getName() + ChatColor.WHITE);
						emp++;
					} else {
						plugins.add(ChatColor.DARK_GREEN + pl.getName() + ChatColor.WHITE);
						dmp++;
					}
				} else if (pl.getDescription().getAuthors() != null) {
					if (pl.getDescription().getAuthors().contains("tulir293")) {
						if (pl.isEnabled()) {
							plugins.add(ChatColor.GREEN + pl.getName() + ChatColor.WHITE);
							emp++;
						} else {
							plugins.add(ChatColor.DARK_GREEN + pl.getName() + ChatColor.WHITE);
							dmp++;
						}
					} else {
						if (pl.isEnabled()) {
							plugins.add(ChatColor.AQUA + pl.getName() + ChatColor.WHITE);
							ep++;
						} else {
							plugins.add(ChatColor.RED + pl.getName() + ChatColor.WHITE);
							dp++;
						}
					}
				} else if (pl.getDescription().getWebsite() != null) {
					if (pl.getDescription().getWebsite().toLowerCase().contains("maunium.net")) {
						if (pl.isEnabled()) {
							plugins.add(ChatColor.GREEN + pl.getName() + ChatColor.WHITE);
							emp++;
						} else {
							plugins.add(ChatColor.DARK_GREEN + pl.getName() + ChatColor.WHITE);
							dmp++;
						}
					} else {
						if (pl.isEnabled()) {
							plugins.add(ChatColor.AQUA + pl.getName() + ChatColor.WHITE);
							ep++;
						} else {
							plugins.add(ChatColor.RED + pl.getName() + ChatColor.WHITE);
							dp++;
						}
					}
				} else {
					if (pl.isEnabled()) {
						plugins.add(ChatColor.AQUA + pl.getName() + ChatColor.WHITE);
						ep++;
					} else {
						plugins.add(ChatColor.RED + pl.getName() + ChatColor.WHITE);
						dp++;
					}
				}
			}
			Collections.sort(plugins, String.CASE_INSENSITIVE_ORDER);
			StringBuffer sb = new StringBuffer();
			for (String s : plugins) {
				sb.append(s);
				sb.append(", ");
			}
			sb.delete(sb.length() - 2, sb.length());
			p.sendMessage(ChatColor.GREEN + "Enabled MauPlugin (" + emp + ")" + ChatColor.WHITE + " - " + ChatColor.DARK_GREEN + "Disabled MauPlugin (" + dmp + ")");
			p.sendMessage(ChatColor.AQUA + "Enabled Plugin (" + ep + ")" + ChatColor.WHITE + " - " + ChatColor.RED + "Disabled Plugin (" + dp + ")");
			p.sendMessage(" ");
			p.sendMessage(sb.toString());
			p.sendMessage(" ");
		}
	}
}
