package net.maunium.bukkit.MauDeathMessages;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.plugin.java.JavaPlugin;

public class MauDeathMessages extends JavaPlugin implements Listener {
	
	public String version;
	public final String name = "MauDeathMessages", author = "Tulir293", stag = ChatColor.DARK_GREEN + "[" + ChatColor.GREEN + name + ChatColor.DARK_GREEN + "] " + ChatColor.GRAY,
			errtag = ChatColor.DARK_RED + "[" + ChatColor.RED + name + ChatColor.DARK_RED + "] " + ChatColor.RED, metatag = "MauDeathMessages_SHOW";
	private List<UUID> uuids;
	
	@Override
	public void onEnable() {
		this.saveDefaultConfig();
		this.getServer().getPluginManager().registerEvents(this, this);
		
		uuids = new ArrayList<UUID>();
		for (String s : getConfig().getStringList("enable-messages"))
			uuids.add(UUID.fromString(s));
	}
	
	@Override
	public void onDisable() {
		List<String> s = new ArrayList<String>(uuids.size());
		for(UUID u : uuids) s.add(u.toString());
		this.getConfig().set("enable-messages", s);
		this.saveConfig();
	}
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent evt) {
		if (uuids.contains(evt.getPlayer().getUniqueId())) evt.getPlayer().setMetadata(metatag, new FixedMetadataValue(this, true));
		evt.setJoinMessage(null);
	}
	
	@EventHandler
	public void onPlayerQuit(PlayerQuitEvent evt){
		evt.getPlayer().removeMetadata(metatag, this);
		evt.setQuitMessage(null);
	}
	
	@EventHandler
	public void onPlayerDeath(PlayerDeathEvent evt) {
		for (Player p : getServer().getOnlinePlayers())
			if (p.hasMetadata(metatag)) p.sendMessage(evt.getDeathMessage());
		evt.setDeathMessage(null);
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (!(sender instanceof Player)) return false;
		Player p = (Player) sender;
		if (p.hasMetadata(metatag)) {
			uuids.remove(p.getUniqueId());
			p.removeMetadata(metatag, this);
			p.sendMessage(stag + "You will no longer see death messages");
		} else {
			uuids.add(p.getUniqueId());
			p.setMetadata(metatag, new FixedMetadataValue(this, true));
			p.sendMessage(stag + "You will now see death messages");
		}
		return true;
	}
}
