package net.maunium.bukkit.MauGo;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;


import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.permissions.Permission;
import org.bukkit.plugin.java.JavaPlugin;

/*
 * 
 * 
 * 
 * SORRY... I'LL MAKE COMMENTING LATER :D
 * 
 * 
 * 
 * 
 */

public class MauGo extends JavaPlugin{
	
	protected String version, name, author, stag, errtag;
	private Map<String, Map<String, Location>> privWarps;
	private Map<String, Location> pubWarps;
	protected Map<String, DelayThread> delays;
	protected Map<Permission, Integer> warpCountPerms;
	
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "7";
		errtag = "c";
		try{
			this.saveDefaultConfig();
			
			Messages.loadMessages(this);
			
			this.getCommand("go").setExecutor(new CommandGo(this));
			this.getCommand("goadmin").setExecutor(new CommandGoAdmin(this));
			this.getCommand("gopublic").setExecutor(new CommandGoPublic(this));
			
			delays = new HashMap<String, DelayThread>();
			warpCountPerms = new HashMap<Permission, Integer>();
			
			privWarps = new HashMap<String, Map<String, Location>>();
			pubWarps = new HashMap<String, Location>();
			
			Map<String, Object> m = getConfig().getConfigurationSection("warp-max").getValues(true);
			for(Entry<String, Object> e : m.entrySet()){
				Permission p = new Permission("maugo.max." + e.getKey());
				this.getServer().getPluginManager().addPermission(p);
				warpCountPerms.put(p, Integer.parseInt(e.getValue() + ""));
			}
			
			if(getConfig().getInt("autosave-interval-mins") > 0){
				new SaveThread(this, getConfig().getInt("autosave-interval-mins"));
			}
			
			if(getConfig().getBoolean("warping.stop-tp-on.move")){
				this.getServer().getPluginManager().registerEvents(new MoveListener(this), this);
			}
			if(getConfig().getBoolean("warping.stop-tp-on.damage")){
				this.getServer().getPluginManager().registerEvents(new DamageListener(this), this);
			}
			if(getConfig().getBoolean("warping.stop-tp-on.command")){
				this.getServer().getPluginManager().registerEvents(new CommandListener(this), this);
			}
			this.getServer().getPluginManager().registerEvents(new JQListener(this), this);
			
			for(Player p : getServer().getOnlinePlayers()){
				loadPrivWarps(p.getName());
			}
			
			Permission allPubs = new Permission("maugo.public.*");
			if(getConfig().getConfigurationSection("public-warps") == null){
				getLogger().info("There seem to be no public warps. Skipping pubWarp loader.");
			} else {
				for(Entry<String, Object> e : getConfig().getConfigurationSection("public-warps").getValues(true).entrySet()){
					Location l;
					try{
						l = parseLocation(e.getValue().toString());
					} catch (Exception ex){
						l = null;
					}
					if(l != null){
						pubWarps.put(e.getKey(), l);
						Permission p = new Permission("maugo.public." + e.getKey());
						p.addParent(allPubs, true);
						getServer().getPluginManager().addPermission(p);
					} else {
						getLogger().severe("Error while parsing public warp " + e.getKey() + ".");
					}
				}
			}
		} catch (Exception e){
			e.printStackTrace();
		}
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	@Override
	public void onDisable(){
		long st = System.currentTimeMillis();
		
		for(Player p : getServer().getOnlinePlayers()){
			savePrivWarps(p.getName());
		}
		savePubWarps();
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	
	protected void loadPrivWarps(String player){
		File f = new File(getDataFolder() + File.separator + "private-warps" + File.separator + player + ".yml");
		f.getParentFile().mkdirs();
		Map<String, Location> warps = new HashMap<String, Location>();
		if(f.exists()){
			FileConfiguration config = YamlConfiguration.loadConfiguration(f);
			if(config.getConfigurationSection("warps") != null){
				Map<String, Object> temp = config.getConfigurationSection("warps").getValues(true);
				for(Entry<String, Object> e : temp.entrySet()){
					if(f.equals(warps)/*reachedLimit()*/){
						
					}
					Location l;
					try{
						l = parseLocation(e.getValue().toString());
					} catch (Exception ex){
						l = null;
					}
					if(l != null){
						warps.put(e.getKey(), l);
					} else {
						getLogger().severe("Error while parsing " + player + "'s warp " + e.getKey() + ".");
					}
				}
			}
		}
		setPrivWarps(player, warps);
	}
	protected void savePrivWarps(String player){
		File f = new File(getDataFolder() + File.separator + "private-warps" + File.separator + player + ".yml");
		f.getParentFile().mkdirs();
		FileConfiguration config = new YamlConfiguration();
		for(Entry<String, Location> e : getPrivWarps(player).entrySet()){
			config.set("warps." + e.getKey(), locToString(e.getValue()));
		}
		try {
			config.save(f);
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}
	protected void savePubWarps(){
		for(Entry<String, Location> e : getPubWarps().entrySet()){
			getConfig().set("public-warps." + e.getKey(), locToString(e.getValue()));
		}
		if(getPubWarps().isEmpty()){
			getConfig().set("public-warps", new ArrayList<String>());
		}
		this.saveConfig();
	}
	
	protected int getMaxWarps(Player player){
		int maxWarps = -1;
		for(Entry<Permission, Integer> e : warpCountPerms.entrySet()){
			if(player.hasPermission(e.getKey())){
				maxWarps = e.getValue();
			}
		}
		if(maxWarps == -1){
			maxWarps = 1;
		}
		return maxWarps;
	}
	protected int getWarpCount(String player){
		if(getPrivWarps(player) != null){
			int warps = getPrivWarps(player).size();
			return warps;
		} else {
			return 0;
		}
	}
	protected boolean reachedLimit(Player player){
		if(getMaxWarps(player) <= getWarpCount(player.getName())){
			return true;
		} else {
			return false;
		}
	}
	protected boolean addPrivWarp(String player, String name, Location l){
		name = name.toLowerCase();
		Map<String, Location> pPW = getPrivWarps(player);
		boolean replaced = false;
		if(pPW.containsKey(name)){
			replaced = true;
		}
		pPW.put(name, l);
		privWarps.put(player, pPW);
		return replaced;
	}
	protected boolean delPrivWarp(String player, String name){
		name = name.toLowerCase();
		Map<String, Location> pPW = getPrivWarps(player);
		if(pPW.containsKey(name)){
			pPW.remove(name);
			privWarps.put(player, pPW);
			return true;
		} else {
			return false;
		}
	}
	protected boolean addPubWarp(String name, Location l){
		name = name.toLowerCase();
		if(pubWarps.containsKey(name)){
			pubWarps.put(name, l);
			return true;
		} else {
			pubWarps.put(name, l);
			return false;
		}
	}
	protected boolean delPubWarp(String name){
		name = name.toLowerCase();
		if(pubWarps.containsKey(name)){
			pubWarps.remove(name);
			return true;
		} else {
			return false;
		}
	}
	protected Location getPrivWarp(String player, String name){
		name = name.toLowerCase();
		if(getPrivWarps(player).containsKey(name)){
			return getPrivWarps(player).get(name);
		} else {
			return null;
		}
	}
	protected Location getPubWarp(String name){
		name = name.toLowerCase();
		if(pubWarps.containsKey(name)){
			return pubWarps.get(name);
		} else {
			return null;
		}
	}
	protected Map<String, Location> getPubWarps(){
		return pubWarps;
	}
	protected Map<String, Location> getPrivWarps(String player){
		if(privWarps.get(player) != null){
			return privWarps.get(player);
		} else {
			return new HashMap<String, Location>();
		}
	}
	protected void setPrivWarps(String player, Map<String, Location> warps){
		privWarps.put(player, warps);
	}
	protected Location parseLocation(String s) throws NumberFormatException, NullPointerException{
		String[] temp = s.split(", ");
		double x, y, z;
		float yaw, pitch;
		World w;
		try{
			x = Double.parseDouble(temp[0]);
			y = Double.parseDouble(temp[1]);
			z = Double.parseDouble(temp[2]);
			yaw = Float.parseFloat(temp[3]);
			pitch = Float.parseFloat(temp[4]);
		} catch (NumberFormatException e){
			throw new NumberFormatException();
		} catch (NullPointerException e){
			throw new NullPointerException();
		}
		
		if(getServer().getWorld(temp[5]) != null){
			w = getServer().getWorld(temp[5]);
		} else {
			return null;
		}
		return new Location(w, x, y, z, yaw, pitch);
	}
	protected String locToString(Location l){
		String s = l.getX() + ", " + l.getY() + ", " + l.getZ() + ", " + l.getYaw() + ", " + l.getPitch() + ", " + l.getWorld().getName();
		return s;
	}
	protected void help(Player p, String label){
		p.sendMessage("3-- aGo Help 3--");
		p.sendMessage("c/" + label + " set <warpname>6 - Create a private warp.");
		p.sendMessage("c/" + label + " del <warpname>6 - Remove a private warp.");
		p.sendMessage("c/" + label + " list6 - List all warps.");
		p.sendMessage("c/" + label + " <warpname>6 - Teleport to the specified warp.");
	}
}
