package net.maunium.bukkit.MauKits;

import java.util.Collection;

import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;
import org.bukkit.potion.PotionEffect;

public class Kit {
	ItemStack[] slots;
	ItemStack[] armor;
	Collection<PotionEffect> effects;
	private String name;
	public Kit(String name, PlayerInventory pi, Collection<PotionEffect> effects){
		this.name = name;
		this.armor = new ItemStack[4];
		this.armor[0] = pi.getBoots();
		this.armor[1] = pi.getLeggings();
		this.armor[2] = pi.getChestplate();
		this.armor[3] = pi.getHelmet();
		this.slots = new ItemStack[36];
		for(int i = 0; i < 36; i++){
			if(pi.getItem(i) != null){
				this.slots[i] = pi.getItem(i);
			} else {
				this.slots[i] = new ItemStack(Material.AIR);
			}
		}
		this.effects = effects;
	}
	public Kit(String name, ItemStack[] slots, ItemStack[] armor, Collection<PotionEffect> effects){
		this.name = name;
		this.armor = armor;
		this.slots = slots;
		this.effects = effects;
	}
	public String getPermission() {
		return "maukits.kits." + name;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public boolean setSlot(int slot, ItemStack is){
		if(slot < 36 && slot > -1){
			slots[slot] = is;
			return true;
		} else {
			return false;
		}
	}
	public ItemStack getSlot(int slot){
		if(slot < 36 && slot > -1){
			return slots[slot];
		} else {
			return null;
		}
	}
	@SuppressWarnings("deprecation")
	public void giveKitTo(Player p){
		for (PotionEffect effect : p.getActivePotionEffects()){
			p.removePotionEffect(effect.getType());
		}
		p.getInventory().clear();
		PlayerInventory pi = p.getInventory();
		pi.setBoots(armor[0]);
		pi.setLeggings(armor[1]);
		pi.setChestplate(armor[2]);
		pi.setHelmet(armor[3]);
		for(int i = 0; i < 36; i++){
			pi.setItem(i, slots[i]);
		}
		p.getInventory().setContents(pi.getContents());
		p.getInventory().setArmorContents(pi.getArmorContents());
		if(!effects.isEmpty()){
			p.addPotionEffects(effects);
		}
		p.updateInventory();
	}
}
