package net.maunium.bukkit.MauLand;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;

public class MauLand extends JavaPlugin implements Listener {
	
	public String version;
	public final String name = "MauLand", author = "Tulir293", stag = ChatColor.DARK_GREEN + "[" + ChatColor.GREEN + name + ChatColor.DARK_GREEN + "] " + ChatColor.GRAY, errtag = ChatColor.DARK_RED
			+ "[" + ChatColor.RED + name + ChatColor.DARK_RED + "] " + ChatColor.RED;
	public final String tpMeta = "MauLandIsTPing";
	private WorldManager wm;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		
		getLogger().info("Loading MauLand world...");
		wm = new WorldManager(this);
		wm.load();
		
		getServer().setSpawnRadius(8);
		
		getLogger().info("Registering listeners...");
		this.getServer().getPluginManager().registerEvents(new BuildListener(this), this);
		this.getServer().getPluginManager().registerEvents(new JQListener(this), this);
		this.getServer().getPluginManager().registerEvents(new EntityListener(this), this);
		this.getServer().getPluginManager().registerEvents(new TeleportListener(this), this);
		this.getServer().getPluginManager().registerEvents(new PreCommandListener(this), this);
		this.getServer().getPluginManager().registerEvents(new InteractListener(this), this);
		
		getLogger().info("Setting command executor...");
		this.getCommand("mauland").setExecutor(new CommandMauland(this));
		
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + (System.currentTimeMillis() - st) + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		getLogger().info("Teleporting players out of MauLand");
		for (Player p : getServer().getOnlinePlayers())
			if (getWorldManager().isMauLand(p)) getWorldManager().teleportOut(p);
		getLogger().info("Saving and unloading MauLand world...");
		wm.close();
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + (System.currentTimeMillis() - st) + "ms.");
	}
	
	public WorldManager getWorldManager() {
		return wm;
	}
}