package net.maunium.bukkit.MauLand;

import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityPortalEvent;
import org.bukkit.event.player.PlayerPortalEvent;
import org.bukkit.event.player.PlayerTeleportEvent;

public class TeleportListener implements Listener {
	private MauLand plugin;
	
	public TeleportListener(MauLand plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler
	public void onPortalTeleport(PlayerPortalEvent evt) {
		if (plugin.getWorldManager().isMauLand(evt.getFrom()) && !evt.getPlayer().hasPermission("mauland.trusted")) {
			evt.setCancelled(true);
			evt.getPlayer().sendMessage(plugin.errtag + "You can only leave MauLand using the \"/mauland\" command.");
		}
	}
	
	@EventHandler
	public void onPortalTeleport(EntityPortalEvent evt) {
		if (plugin.getWorldManager().isMauLand(evt.getFrom())) evt.setCancelled(true);
	}
	
	@EventHandler
	public void onTeleport(PlayerTeleportEvent evt) {
		if (!evt.getPlayer().hasPermission("mauland.trusted") && !evt.getPlayer().hasMetadata(plugin.tpMeta)) {
			if(plugin.getWorldManager().isMauLand(evt.getFrom()) && !plugin.getWorldManager().isMauLand(evt.getTo())){
				evt.setCancelled(true);
				evt.setTo(evt.getFrom());
				evt.getPlayer().sendMessage(plugin.errtag + "You can only leave MauLand using the \"/mauland\" command.");
			} else if (!plugin.getWorldManager().isMauLand(evt.getFrom()) && plugin.getWorldManager().isMauLand(evt.getTo())){
				evt.setCancelled(true);
				evt.setTo(evt.getFrom());
				evt.getPlayer().sendMessage(plugin.errtag + "You can only enter MauLand using the \"/mauland\" command.");
			}
		}
		if (evt.getPlayer().hasMetadata(plugin.tpMeta)) evt.getPlayer().removeMetadata(plugin.tpMeta, plugin);
	}
}
