package net.maunium.bukkit.MauLaunchers;

import java.util.Arrays;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class CommandLaunchers implements CommandExecutor {
	private MauLaunchers plugin;
	
	public CommandLaunchers(MauLaunchers plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (!(sender instanceof Player)) {
			sender.sendMessage(plugin.errtag + "You must be in-game to use this command!");
			return true;
		}
		Player p = (Player) sender;
		if (args.length > 0) {
			if (args[0].equalsIgnoreCase("creator") || args[0].equalsIgnoreCase("c") || args[0].equalsIgnoreCase("cr")) p.getInventory().addItem(creator());
			else if (args[0].equalsIgnoreCase("remover") || args[0].equalsIgnoreCase("r") || args[0].equalsIgnoreCase("rm")) p.getInventory().addItem(remover());
			else if (args[0].equalsIgnoreCase("inspector") || args[0].equalsIgnoreCase("inspect") || args[0].equalsIgnoreCase("ins")) p.getInventory().addItem(inspector());
			else if (args[0].equalsIgnoreCase("initialize") || args[0].equalsIgnoreCase("i") || args[0].equalsIgnoreCase("init")) {
				if (args.length > 3) {
					if (p.getItemInHand().hasItemMeta() && p.getItemInHand().getItemMeta().hasDisplayName() && p.getItemInHand().getItemMeta().getDisplayName().equals(ChatColor.DARK_GREEN + "MauLauncher Creator")) {
						double x, y, z;
						try {
							x = Double.parseDouble(args[1]);
							y = Double.parseDouble(args[2]);
							z = Double.parseDouble(args[3]);
						} catch (NumberFormatException e) {
							p.sendMessage(plugin.errtag + "Velocity X, Y and Z must be decimal numbers.");
							return true;
						}
						ItemMeta im = p.getItemInHand().getItemMeta();
						im.setLore(Arrays.asList(ChatColor.GREEN + "Ready to Create!", x + ", " + y + ", " + z));
						p.getItemInHand().setItemMeta(im);
					} else p.sendMessage(plugin.errtag + "You don't have a MauLauncher Creator in your hand!");
				} else return false;
			} else return false;
			return true;
		} else return false;
	}
	
	private static ItemStack creator, remover, inspector;
	
	static {
		creator = new ItemStack(Material.STICK);
		ItemMeta im = creator.getItemMeta();
		im.setDisplayName(ChatColor.DARK_GREEN + "MauLauncher Creator");
		im.setLore(Arrays.asList(ChatColor.RED + "Not initialized"));
		creator.setItemMeta(im);
		remover = new ItemStack(Material.BLAZE_ROD);
		im = remover.getItemMeta();
		im.setDisplayName(ChatColor.DARK_RED + "MauLauncher Remover");
		remover.setItemMeta(im);
		inspector = new ItemStack(Material.FEATHER);
		im = inspector.getItemMeta();
		im.setDisplayName(ChatColor.DARK_AQUA + "MauLauncher Inspector");
		inspector.setItemMeta(im);
	}
	
	public static ItemStack creator() {
		return creator.clone();
	}
	
	public static ItemStack remover() {
		return remover.clone();
	}
	
	public static ItemStack inspector() {
		return inspector.clone();
	}
}
