package net.maunium.bukkit.MauLaunchers;

import org.bukkit.ChatColor;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;

public class PlayerInteractListener implements Listener {
	private MauLaunchers plugin;
	
	public PlayerInteractListener(MauLaunchers plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler
	public void onPlayerInteract(PlayerInteractEvent evt) {
		if (evt.getAction().equals(Action.RIGHT_CLICK_BLOCK) && evt.getItem() != null) {
			if (evt.getItem().equals(CommandLaunchers.inspector())) {
				Block b = evt.getClickedBlock();
				Launcher l = plugin.getLauncher(b);
				if (l != null) evt.getPlayer().sendMessage(plugin.stag + "Found " + l);
				else evt.getPlayer().sendMessage(plugin.errtag + "Could not find launcher @ " + b.getX() + ", " + b.getY() + ", " + b.getZ() + " in world " + b.getWorld().getName());
			} else if (evt.getItem().equals(CommandLaunchers.remover())) {
				Block b = evt.getClickedBlock();
				if (plugin.removeLauncher(b)) evt.getPlayer().sendMessage(plugin.stag + "Successfully removed launcher @ " + b.getX() + ", " + b.getY() + ", " + b.getZ() + " in world " + b.getWorld().getName());
				else evt.getPlayer().sendMessage(plugin.errtag + "Could not find launcher @ " + b.getX() + ", " + b.getY() + ", " + b.getZ() + " in world " + b.getWorld().getName());
			} else if (evt.getItem().equals(CommandLaunchers.creator())) evt.getPlayer().sendMessage(plugin.errtag + "Creator not initialized!");
			else if (evt.getItem().hasItemMeta() && evt.getItem().getItemMeta().hasDisplayName() && evt.getItem().getItemMeta().hasLore()
					&& evt.getItem().getItemMeta().getDisplayName().equals(ChatColor.DARK_GREEN + "MauLauncher Creator")
					&& evt.getItem().getItemMeta().getLore().get(0).equals(ChatColor.GREEN + "Ready to Create!")) {
				String[] ss = evt.getItem().getItemMeta().getLore().get(1).split(", ");
				double x = Double.parseDouble(ss[0]);
				double y = Double.parseDouble(ss[1]);
				double z = Double.parseDouble(ss[2]);
				Block b = evt.getClickedBlock();
				Launcher l = new Launcher(b, x, y, z);
				evt.getPlayer().sendMessage(plugin.stag + (plugin.addLauncher(l) ? "Re-" : "") + "Created " + l);
			}
		}
	}
}
