package net.maunium.bukkit.MauOwnKits;

import java.io.Serializable;

import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

public class InvSet implements Serializable {
	static final long serialVersionUID = 29307000L;
	protected int maxInventories;
	protected ItemStack[][] armor;
	protected ItemStack[][] mainInv;
	
	public InvSet() {
		this(3);
	}
	
	public InvSet(int maxInventories) {
		this.maxInventories = maxInventories;
		this.armor = new ItemStack[maxInventories][];
		this.mainInv = new ItemStack[maxInventories][];
	}
	
	public int getMaxInventories() {
		return this.maxInventories;
	}
	
	@SuppressWarnings("deprecation")
	public void equip(Player p, int id) {
		id--;
		if (containsInventory(id + 1)) {
			p.getInventory().setArmorContents(this.armor[id]);
			p.getInventory().setContents(this.mainInv[id]);
			
			p.updateInventory();
		}
	}
	
	@SuppressWarnings("deprecation")
	public void save(Player p, int id) {
		id--;
		if (id < this.maxInventories) {
			this.armor[id] = p.getInventory().getArmorContents();
			this.mainInv[id] = p.getInventory().getContents();
		}
		p.getInventory().clear();
		p.getInventory().setArmorContents(new ItemStack[4]);
		p.updateInventory();
	}
	
	public boolean containsInventory(int id) {
		id--;
		if (this.armor.length > id && this.mainInv.length > id) {
			if (this.armor[id] != null && this.mainInv[id] != null) { return true; }
		}
		return false;
	}
}
