package net.maunium.bukkit.MauOwnKits;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import org.bukkit.entity.Player;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.util.io.BukkitObjectInputStream;
import org.bukkit.util.io.BukkitObjectOutputStream;

public class MauOwnKits extends JavaPlugin {
	
	public String version, name, author, errtag, stag;
	public final String msis = "MauSavedInvSet";
	public Properties lang = new Properties();
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		this.version = getDescription().getVersion();
		this.name = getDescription().getName();
		this.author = getDescription().getAuthors().get(0);
		
		this.saveDefaultConfig();
		String langtmp = getConfig().getString("language") + ".lang";
		File langFile = new File(getDataFolder(), langtmp);
		if (!langFile.exists()) {
			this.saveResource(langtmp, false);
		}
		
		lang = new Properties();
		try {
			InputStream langIS = new FileInputStream(langFile);
			lang.load(langIS);
			this.name = lang.getProperty("name");
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		this.stag = "2[a" + this.name + "2]7 ";
		this.errtag = "4[c" + this.name + "4]c ";
		
		for (Player p : getServer().getOnlinePlayers())
			loadInv(p);
		
		getServer().getPluginManager().registerEvents(new InteractListener(this), this);
		getServer().getPluginManager().registerEvents(new Listeners(this), this);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(this.name + " v" + this.version + " by " + this.author + " enabled in " + et + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		
		for (Player p : getServer().getOnlinePlayers())
			saveInv(p);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(this.name + " v" + this.version + " by " + this.author + " disabled in " + et + "ms.");
	}
	
	public void saveInv(Player p) {
		File f = new File(this.getDataFolder(), p.getUniqueId() + ".mauinv");
		if (p.hasMetadata(this.msis)) {
			MetadataValue mv = getMetadata(p, this.msis);
			if (mv == null) return;
			if (mv.value() == null) return;
			if (!(mv.value() instanceof InvSet)) return;
			
			try (BukkitObjectOutputStream oos = new BukkitObjectOutputStream(new FileOutputStream(f))) {
				oos.writeObject(mv.value());
				oos.flush();
			} catch (IOException e) {
				e.printStackTrace();
			}
			p.removeMetadata(this.msis, this);
		}
	}
	
	public void loadInv(Player p) {
		File f = new File(this.getDataFolder(), p.getUniqueId() + ".mauinv");
		if (!f.exists()) return;
		try (BukkitObjectInputStream ois = new BukkitObjectInputStream(new FileInputStream(f))) {
			Object o = ois.readObject();
			if (!(o instanceof InvSet)) {
				getLogger().severe("Found a .mauinv file that doesn't contain an InvSet!");
				f.renameTo(new File(f + ".corrupted"));
				return;
			}
			InvSet inv = (InvSet) o;
			p.setMetadata(this.msis, new FixedMetadataValue(this, inv));
		} catch (IOException | ClassNotFoundException e) {
			f.renameTo(new File(f + ".corrupted"));
			e.printStackTrace();
		}
	}
	
	public MetadataValue getMetadata(Player p, String key) {
		for (MetadataValue m : p.getMetadata(key)) {
			if (m.getOwningPlugin().getName().equals(getName())) { return m; }
		}
		return null;
	}
}
