package net.maunium.bukkit.MauPerms.Commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import net.maunium.bukkit.MauBukLib.ChatFormatter;
import net.maunium.bukkit.MauBukLib.MauBukLib;
import net.maunium.bukkit.MauPerms.MauPerms;
import net.maunium.bukkit.MauPerms.Permissions.PermissionManager;
import net.maunium.bukkit.MauPerms.Permissions.PlayerPerms;

public class CommandNick implements CommandExecutor {
	
	private MauPerms plugin;
	
	public CommandNick(MauPerms plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (sender.hasPermission("mauperms.nick")) {
			if (sender.hasPermission("mauperms.nick.others") && args.length > 1 && MauBukLib.getUtils().getPlayer(args[0]) != null) {
				Player p = MauBukLib.getUtils().getPlayer(args[0]);
				StringBuffer sb = new StringBuffer();
				for (int i = 1; i < args.length; i++) {
					sb.append(args[i] + " ");
				}
				sb.deleteCharAt(sb.length() - 1);
				setNick(sender, p, sb.toString());
				return true;
			} else if (!(sender instanceof Player)) {
				sender.sendMessage(plugin.errtag + plugin.format("nick.playernotfound"));
				return true;
			} else if (args.length > 0) {
				Player p = (Player) sender;
				StringBuffer sb = new StringBuffer();
				for (String s : args) {
					sb.append(s + " ");
				}
				sb.deleteCharAt(sb.length() - 1);
				setNick(p, sb.toString());
				return true;
			}
		}
		return false;
	}
	
	private void setNick(Player p, String nick) {
		setNick(p, p, nick);
	}
	
	private void setNick(CommandSender sender, Player p, String nick) {
		if (sender.hasPermission("mauperms.nick.color")) nick = ChatFormatter.color(nick);
		if (sender.hasPermission("mauperms.nick.format")) nick = ChatFormatter.format(nick);
		if (sender.hasPermission("mauperms.nick.magic")) nick = ChatFormatter.magic(nick);
		
		p.setDisplayName(nick);
		if (plugin.getConfig().getBoolean("change-tablistname")) {
			if (nick.length() > 16) {
				nick = nick.substring(0, 16);
				p.setPlayerListName(nick);
			}
		}
		PermissionManager pm = PermissionManager.getInstance();
		PlayerPerms pp = pm.getPlayer(p.getUniqueId());
		pp.setNick(nick);
		pm.setPlayer(p.getUniqueId(), pp);
		sender.sendMessage(plugin.stag + plugin.format("nick.set", p.getName(), nick));
	}
}
