package net.maunium.bukkit.MauSongPlayer;

import org.bukkit.Sound;

public class MauNote {
	public final byte instrument, key;
	
	public MauNote(byte instrument, byte key) {
		this.instrument = instrument;
		this.key = key;
	}
	
	public Sound getInstrumentSound() {
		switch (instrument) {
			case 0:
				return Sound.NOTE_PIANO;
			case 1:
				return Sound.NOTE_BASS_GUITAR;
			case 2:
				return Sound.NOTE_BASS_DRUM;
			case 3:
				return Sound.NOTE_SNARE_DRUM;
			case 4:
				return Sound.NOTE_STICKS;
			default:
				return Sound.NOTE_PIANO;
		}
	}
	
	public static enum Pitch {
		NOTE_0(0, 0.5F),
		NOTE_1(1, 0.53F),
		NOTE_2(2, 0.56F),
		NOTE_3(3, 0.6F),
		NOTE_4(4, 0.63F),
		NOTE_5(5, 0.67F),
		NOTE_6(6, 0.7F),
		NOTE_7(7, 0.76F),
		NOTE_8(8, 0.8F),
		NOTE_9(9, 0.84F),
		NOTE_10(10, 0.9F),
		NOTE_11(11, 0.94F),
		NOTE_12(12, 1.0F),
		NOTE_13(13, 1.06F),
		NOTE_14(14, 1.12F),
		NOTE_15(15, 1.18F),
		NOTE_16(16, 1.26F),
		NOTE_17(17, 1.34F),
		NOTE_18(18, 1.42F),
		NOTE_19(19, 1.5F),
		NOTE_20(20, 1.6F),
		NOTE_21(21, 1.68F),
		NOTE_22(22, 1.78F),
		NOTE_23(23, 1.88F),
		NOTE_24(24, 2.0F);
		
		public final int note;
		public final float pitch;
		
		private Pitch(int note, float pitch) {
			this.note = note;
			this.pitch = pitch;
		}
		
		public static float getPitch(int note) {
			for (Pitch notePitch : values())
				if (notePitch.note == note) return notePitch.pitch;
			return 0.0F;
		}
	}
}
