package net.maunium.bukkit.MauSongPlayer;

import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

public class MauPrivatePlayer extends MauPlayer {
	private UUID playingFor;
	
	public MauPrivatePlayer(MauSong song, Player p) {
		super(song);
		playingFor = p.getUniqueId();
	}
	
	@Override
	public boolean playTick(int tick) {
		Player p = Bukkit.getPlayer(playingFor);
		if (p != null) {
			for (MauLayer l : getSong().getLayerHashMap().values()) {
				MauNote note = l.getNote(tick);
				if (note == null) continue;
				p.playSound(p.getLocation(), note.getInstrumentSound(), l.getVolume() * getVolume() * 100 / 1000000f, MauNote.Pitch.getPitch(note.key - 33));
			}
			return true;
		} else return false;
	}
}
