package net.maunium.bukkit.MauUtils.Commands;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import net.maunium.bukkit.MauUtils.MauUtils;

public class CommandPlugins{
	private MauUtils plugin;
	
	public CommandPlugins(MauUtils plugin) {
		this.plugin = plugin;
	}
	
	public void execute(Player sender, String command) {
		if(!sender.hasPermission("mauutils.plugins")){
			sender.sendMessage(plugin.errtag + "You don't have the permission to do that!");
			return;
		}
		List<String> plugins = new ArrayList<String>();
		int emp = 0;
		int dmp = 0;
		int ep = 0;
		int dp = 0;
		for (Plugin p : plugin.getServer().getPluginManager().getPlugins()) {
			if(p.getName().toLowerCase().contains("mau") ||
					p.getDescription().getMain().startsWith("net.maunium")){
				if(p.isEnabled()){
					plugins.add(ChatColor.GREEN + p.getName() + ChatColor.WHITE);
					emp++;
				} else {
					plugins.add(ChatColor.DARK_GREEN + p.getName() + ChatColor.WHITE);
					dmp++;
				}
			} else if(p.getDescription().getAuthors() != null){
				if(p.getDescription().getAuthors().contains("tulir293")){
					if (p.isEnabled()) {
						plugins.add(ChatColor.GREEN + p.getName() + ChatColor.WHITE);
						emp++;
					} else {
						plugins.add(ChatColor.DARK_GREEN + p.getName() + ChatColor.WHITE);
						dmp++;
					}
				} else {
					if(p.isEnabled()){
						plugins.add(ChatColor.AQUA + p.getName() + ChatColor.WHITE);
						ep++;
					} else {
						plugins.add(ChatColor.RED + p.getName() + ChatColor.WHITE);
						dp++;
					}
				}
			} else if (p.getDescription().getWebsite() != null){
				if(p.getDescription().getWebsite().toLowerCase().contains("maunium.net")){
					if (p.isEnabled()) {
						plugins.add(ChatColor.GREEN + p.getName() + ChatColor.WHITE);
						emp++;
					} else {
						plugins.add(ChatColor.DARK_GREEN + p.getName() + ChatColor.WHITE);
						dmp++;
					}
				} else {
					if(p.isEnabled()){
						plugins.add(ChatColor.AQUA + p.getName() + ChatColor.WHITE);
						ep++;
					} else {
						plugins.add(ChatColor.RED + p.getName() + ChatColor.WHITE);
						dp++;
					}
				}
			} else {
				if(p.isEnabled()){
					plugins.add(ChatColor.AQUA + p.getName() + ChatColor.WHITE);
					ep++;
				} else {
					plugins.add(ChatColor.RED + p.getName() + ChatColor.WHITE);
					dp++;
				}
			}
		}
		Collections.sort(plugins, String.CASE_INSENSITIVE_ORDER);
		StringBuffer sb = new StringBuffer();
		for(String s : plugins){
			sb.append(s + ", ");
		}
		sb.delete(sb.length() - 2, sb.length());
		sender.sendMessage(ChatColor.YELLOW + "List of plugins on " + ChatColor.GREEN + ChatColor.BOLD + "Maunium" + ChatColor.YELLOW + ".");
		sender.sendMessage(ChatColor.GREEN + "Enabled MauPlugin (" + emp + ")" + ChatColor.WHITE + " - " + ChatColor.DARK_GREEN + "Disabled MauPlugin (" + dmp + ")");
		sender.sendMessage(ChatColor.AQUA + "Enabled Plugin (" + ep + ")" + ChatColor.WHITE + " - " + ChatColor.RED + "Disabled Plugin (" + dp + ")");
		sender.sendMessage(" ");
		sender.sendMessage(sb.toString());
		sender.sendMessage(" ");
	}
}
