package net.maunium.bukkit.MauUtils.Listeners;

import java.util.List;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.OfflinePlayer;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.server.ServerListPingEvent;

import net.maunium.bukkit.MauBukLib.MauBukLib;
import net.maunium.bukkit.MauUtils.MauUtils;

public class PingListener implements Listener {
	
	private MauUtils plugin;
	
	public PingListener(MauUtils plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onPing(ServerListPingEvent evt) {
		evt.setMaxPlayers(35);
		String pn = evt.getAddress().getHostAddress();
		
		if (plugin.getConfig().getBoolean("fancy-ping-motd.show-ipban")) {
			if (Bukkit.getServer().getIPBans().contains(pn)) {
				evt.setMotd(evt.getMotd() + ChatColor.RESET + "\nSinut on bannattu, " + pn);
				return;
			}
		}
		
		if (plugin.getConfig().getBoolean("fancy-ping-motd.show-username")) {
			List<String> players = MauBukLib.getPlayerData().getPlayersByIP(evt.getAddress().getHostAddress());
			if (players.size() == 1) {
				pn = players.get(0);
				if (plugin.getConfig().getBoolean("fancy-ping-motd.show-ban")) {
					List<UUID> uuids = MauBukLib.getPlayerData().getUUIDsByName(pn);
					if (isBanned(uuids.get(0))) {
						evt.setMotd(evt.getMotd() + ChatColor.RESET + "\nSinut on bannattu, " + pn);
						return;
					}
				}
			}
		}
		
		evt.setMotd(evt.getMotd() + ChatColor.RESET + "\nTervetuloa, " + pn);
	}
	
	private boolean isBanned(UUID uuid) {
		for (OfflinePlayer op : Bukkit.getServer().getBannedPlayers()) {
			if (op.getUniqueId().equals(uuid)) return true;
		}
		return false;
	}
}
