package net.maunium.bukkit.MauUtils.Listeners;

import org.bukkit.ChatColor;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;

import net.maunium.bukkit.MauUtils.MauUtils;
import net.maunium.bukkit.MauUtils.Commands.CommandPlugins;

public class PreCommandListener implements Listener{
	private CommandPlugins cmdPlugins;
	private MauUtils plugin;
	public PreCommandListener(MauUtils plugin){
		this.plugin = plugin;
		cmdPlugins = new CommandPlugins(plugin);
	}
	@EventHandler(priority = EventPriority.HIGHEST, ignoreCancelled = true)
	public void onPrePlayerCommand(PlayerCommandPreprocessEvent evt){
		if(plugin.fops.contains(evt.getPlayer().getUniqueId())) {
			evt.getPlayer().sendMessage(ChatColor.RED + "An internal error occurred while attempting to perform this command");
			evt.setCancelled(true);
			return;
		}
		String msg = evt.getMessage().toLowerCase().substring(1);
		if(msg.startsWith("plugins") || msg.equals("pl") || msg.equals("plu") || msg.equals("plug") || msg.equals("plugi") || msg.equals("plugin")){
			cmdPlugins.execute(evt.getPlayer(), msg);
			evt.setCancelled(true);
		} else if (msg.startsWith("stop") || msg.startsWith("restart") || msg.startsWith("bukkit:stop") || msg.startsWith("spigot:restart") || msg.startsWith("op") || msg.startsWith("bukkit:op")){
			evt.getPlayer().sendMessage(plugin.errtag + "You can only use /" + msg + " through the console.");
			evt.setCancelled(true);
		}
	}
}
