package net.maunium.bukkit.MauUtils;

import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

import org.bukkit.command.CommandExecutor;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;

import net.maunium.bukkit.MauBukLib.I18n;
import net.maunium.bukkit.MauUtils.Commands.CommandClearChat;
import net.maunium.bukkit.MauUtils.Commands.CommandFakeChat;
import net.maunium.bukkit.MauUtils.Commands.CommandFakeCommand;
import net.maunium.bukkit.MauUtils.Commands.CommandFakeOP;
import net.maunium.bukkit.MauUtils.Commands.CommandList;
import net.maunium.bukkit.MauUtils.Commands.CommandPlainMessage;
import net.maunium.bukkit.MauUtils.Commands.CommandPlainSay;
import net.maunium.bukkit.MauUtils.Listeners.JQListener;
import net.maunium.bukkit.MauUtils.Listeners.PingListener;
import net.maunium.bukkit.MauUtils.Listeners.PreCommandListener;

public class MauUtils extends JavaPlugin {
	
	public String version, name, author, errtag, stag;
	public Set<UUID> fops = new HashSet<UUID>();
	private I18n i18n;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "2[a" + name + "2]7 ";
		errtag = "4[c" + name + "4]c ";
		this.saveDefaultConfig();
		
		try {
			i18n = new I18n(this.getDataFolder(), this.getConfig().getString("language"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		regList(new PreCommandListener(this));
		regList(new JQListener(this));
		regList(new PingListener(this));
		
		setExec("mauplainsay", new CommandPlainSay(this));
		setExec("mauplainmessage", new CommandPlainMessage(this));
		setExec("mauclearchat", new CommandClearChat(this));
		setExec("maufakechat", new CommandFakeChat(this));
		setExec("maufakecommand", new CommandFakeCommand(this));
		setExec("maufakeop", new CommandFakeOP(this));
		setExec("list", new CommandList(this));
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		
		// TODO: Disable code
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	
	public void setExec(String cmd, CommandExecutor exec) {
		this.getCommand(cmd).setExecutor(exec);
	}
	
	public void regList(Listener l) {
		this.getServer().getPluginManager().registerEvents(l, this);
	}
	
	public String format(String s, Object... args){
		if(i18n != null){
			return i18n.format(s, args);
		} else {
			return s + " -- " + Arrays.toString(args);
		}
	}
}
