package net.maunium.bukkit.MauVanish;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.plugin.java.JavaPlugin;

public class MauVanish extends JavaPlugin implements Listener {
	@Override
	public void onEnable() {
		getServer().getPluginManager().registerEvents(this, this);
	}
	
	private List<UUID> vanished = new ArrayList<UUID>();
	
	@EventHandler
	public void onPlayerCommand(PlayerCommandPreprocessEvent evt) {
		Player p = evt.getPlayer();
		if (!p.hasPermission("mauvanish.use")) return;
		String msg = evt.getMessage().toLowerCase();
		if (msg.startsWith("mauvanish") || msg.startsWith("vanish") || msg.startsWith("mauv") || msg.startsWith("v")) {
			if (this.vanished.contains(p.getUniqueId())) {
				hide(p);
				this.vanished.add(p.getUniqueId());
				
				p.sendMessage(ChatColor.YELLOW + "Poof! You are no longer visible.");
				Bukkit.getServer().broadcastMessage(getConfig().getString("quit").replace("&", "�").replace("{player}", p.getName()));
			} else {
				show(p);
				this.vanished.remove(p.getUniqueId());
				
				p.sendMessage(ChatColor.GREEN + "Poof! You are now visible");
				Bukkit.getServer().broadcastMessage(getConfig().getString("join").replace("&", "�").replace("{player}", p.getName()));
			}
			evt.setCancelled(true);
		}
	}
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent evt) {
		for (UUID p : this.vanished)
			evt.getPlayer().hidePlayer(getServer().getPlayer(p));
	}
	
	@EventHandler
	public void onPlayerLeave(PlayerQuitEvent evt) {
		if (vanished.contains(evt.getPlayer().getUniqueId())) {
			this.vanished.remove(evt.getPlayer().getUniqueId());
			evt.setQuitMessage(null);
			show(evt.getPlayer());
		}
	}
	
	public void show(Player p) {
		for (Player pl : Bukkit.getServer().getOnlinePlayers())
			pl.showPlayer(p);
	}
	
	public void hide(Player p) {
		for (Player pl : Bukkit.getServer().getOnlinePlayers())
			pl.hidePlayer(p);
	}
}
