package net.maunium.bukkit.MauckyBloks;

import java.util.HashMap;
import java.util.Map;

import org.bukkit.Location;
import org.bukkit.configuration.serialization.ConfigurationSerializable;
import org.bukkit.configuration.serialization.SerializableAs;
import org.bukkit.inventory.ItemStack;

@SerializableAs(value = "MauItemEntry")
public class ItemEntry extends LuckyEntry implements ConfigurationSerializable {
	public static MauckyBloks plugin;
	private ItemStack item;
	private double percentChance;
	
	public ItemEntry(ItemStack item, double percentChance) {
		this.item = item;
		this.percentChance = percentChance;
	}
	
	public ItemEntry(Map<String, Object> serialized) {
		Object i = serialized.get("item");
		if (i instanceof ItemStack) this.item = (ItemStack) i;
		else throw new IllegalArgumentException("Serialized map doesn't contain the item.");
		
		Object p = serialized.get("chance");
		try {
			this.percentChance = Double.parseDouble(p.toString());
		} catch (NumberFormatException e) {
			throw new IllegalArgumentException("Serialized map doesn't contain the chance.");
		}
	}
	
	@Override
	public boolean add() {
		return r.nextGaussian() * 100 < percentChance;
	}
	
	@Override
	public Map<String, Object> serialize() {
		Map<String, Object> serialized = new HashMap<String, Object>();
		
		serialized.put("item", item);
		serialized.put("chance", percentChance);
		
		return serialized;
	}
	
	public ItemEntry valueOf(Map<String, Object> serialized) {
		return new ItemEntry(serialized);
	}
	
	public ItemEntry deserialize(Map<String, Object> serialized) {
		return new ItemEntry(serialized);
	}
	
	@Override
	public void spawn(Location l) {
		l.getWorld().dropItemNaturally(l, item);
	}
}