package net.maunium.bukkit.Mauconomy;

import java.sql.SQLException;

import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

public class CommandMauconomy implements CommandExecutor {
	private Mauconomy plugin;
	
	public CommandMauconomy(Mauconomy plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (!plugin.getConfig().getBoolean("enable-admin-commands")) {
			sender.sendMessage(plugin.errtag + "Admin commands have been disabled (config setting)");
			return true;
		}
		if (args.length > 2) {
			boolean verify = plugin.getConfig().getBoolean("verify-admin-commands", true);
			if (args.length > 3) {
				if (args[3].equalsIgnoreCase("--no-verify") || args[3].equalsIgnoreCase("-nv")) {
					verify = false;
				} else if (args[3].equalsIgnoreCase("--verify") || args[3].equalsIgnoreCase("-v")) {
					verify = true;
				}
			}
			
			double amount;
			try {
				amount = parse(args[2]);
			} catch (NumberFormatException e) {
				sender.sendMessage(plugin.errtag + plugin.format("admin.thirdarg"));
				return true;
			}
			
			@SuppressWarnings("deprecation")
			OfflinePlayer player = plugin.getServer().getOfflinePlayer(args[1]);
			if (player != null && player.getUniqueId() != null) {
				if (args[0].equalsIgnoreCase("set")) {
					if (amount < 0) {
						sender.sendMessage(plugin.errtag + plugin.format("admin.set.underzero"));
						return true;
					}
					EconomyData ed = EconomyData.getInstance();
					try {
						ed.setBalance(player.getUniqueId(), amount);
					} catch (SQLException e) {
						sender.sendMessage(plugin.errtag + plugin.format("admin.set.failed", player.getName()));
						e.printStackTrace();
						return true;
					}
					if (verify) {
						double newBalance;
						newBalance = ed.getBalance(player.getUniqueId());
						if (newBalance == amount) {
							sender.sendMessage(plugin.stag + plugin.format("admin.set.success", player.getName(), newBalance, "verified"));
						}
					} else {
						sender.sendMessage(plugin.stag + plugin.format("admin.set.success", player.getName(), amount, "NOT verified"));
					}
					return true;
				} else if (args[0].equalsIgnoreCase("give")) {
					EconomyData ed = EconomyData.getInstance();
					double balance;
					balance = ed.getBalance(player.getUniqueId());
					
					try {
						ed.setBalance(player.getUniqueId(), balance + amount);
					} catch (SQLException e) {
						sender.sendMessage(plugin.errtag + plugin.format("admin.set.failed", player.getName()));
						e.printStackTrace();
						return true;
					}
					if (verify) {
						double newBalance;
						newBalance = ed.getBalance(player.getUniqueId());
						if (newBalance == balance + amount) {
							sender.sendMessage(plugin.stag + plugin.format("admin.give.success", amount, player.getName(), balance, "verified"));
						}
					} else {
						sender.sendMessage(plugin.stag + plugin.format("admin.give.success", balance - amount, player.getName(), balance, "NOT verified"));
					}
					return true;
				} else if (args[0].equalsIgnoreCase("take")) {
					EconomyData ed = EconomyData.getInstance();
					double balance;
					balance = ed.getBalance(player.getUniqueId());
					
					if (balance - amount < 0) {
						sender.sendMessage(plugin.errtag + plugin.format("admin.take.failed"));
						return true;
					}
					
					try {
						ed.setBalance(player.getUniqueId(), balance - amount);
					} catch (SQLException e) {
						sender.sendMessage(plugin.errtag + plugin.format("admin.set.failed", player.getName()));
						e.printStackTrace();
						return true;
					}
					if (verify) {
						double newBalance = ed.getBalance(player.getUniqueId());
						if (newBalance == balance - amount) {
							sender.sendMessage(plugin.stag + plugin.format("admin.take.success", amount, player.getName(), balance, "verified"));
						}
					} else {
						sender.sendMessage(plugin.stag + plugin.format("admin.take.success", balance - amount, player.getName(), balance, "NOT verified"));
					}
					return true;
				}
			}
		}
		return false;
	}
	
	private double parse(String s) {
		try {
			return Double.parseDouble(s);
		} catch (NumberFormatException e1) {
			try {
				return Integer.parseInt(s);
			} catch (NumberFormatException e2) {
				throw e2;
			}
		}
	}
}
