package net.maunium.bukkit.Mauconomy;

import java.io.File;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import java.util.logging.Logger;

import lib.PatPeter.SQLibrary.Database;
import lib.PatPeter.SQLibrary.SQLite;

import net.maunium.bukkit.MauBukLib.MauBukLib;

public class EconomyData {
	private Database sql;
	private static EconomyData instance;
	
	public EconomyData(File dataFolder) {
		sql = new SQLite(Logger.getLogger("Minecraft"), "[Mauconomy] ", dataFolder.getAbsolutePath(), "economy", ".maudb");
		if (!sql.isOpen()) sql.open();
		try {
			sql.query("CREATE TABLE Players(" + "UUID varchar(25) PRIMARY KEY,Balance real NOT NULL);");
		} catch (SQLException e) {}
		instance = this;
	}
	
	public boolean close() {
		return sql.close();
	}
	
	public boolean createAccount(UUID player) {
		try {
			setBalance(player, 0);
			return true;
		} catch (SQLException e) {
			return false;
		}
	}
	
	public String format(double amount) {
		return amount + "M$";
	}
	
	public Map<String, Double> getTop(int limit) {
		try {
			ResultSet rs = sql.query("SELECT * FROM Players order by field Balance limit " + limit);
			Map<String, Double> rtrn = new HashMap<String, Double>();
			while (rs.next()) {
				long rounded = Math.round(rs.getDouble("Balance") * 100.0);
				rtrn.put(MauBukLib.getPlayerData().getPlayerByUUID(UUID.fromString(rs.getString("uuid"))), rounded / 100.0);
			}
			return rtrn;
		} catch (SQLException e) {
			return new HashMap<String, Double>();
		}
	}
	
	public String getBalanceFormatted(UUID player) {
		return format(getBalance(player));
	}
	
	public double getBalance(UUID player) {
		try {
			ResultSet rs = sql.query("SELECT Balance FROM Players WHERE UUID='" + player + "'");
			long rounded = Math.round(rs.getDouble("Balance") * 100.0);
			return rounded / 100.0;
		} catch (SQLException e) {
			return 0;
		}
	}
	
	public void setBalance(UUID player, double balance) throws SQLException {
		long rounded = Math.round(balance * 100);
		sql.query("INSERT OR REPLACE INTO Players VALUES('" + player.toString() + "'," + rounded / 100.0 + ");");
	}
	
	public ResultSet query(String query) throws SQLException, IllegalQueryException {
		if (query.toLowerCase().startsWith("create")) throw new IllegalQueryException("Other classes may not query \"create\"");
		if (query.toLowerCase().startsWith("drop")) throw new IllegalQueryException("Other classes may not query \"drop\"");
		return sql.query(query);
	}
	
	public class IllegalQueryException extends Exception {
		private static final long serialVersionUID = 1356392511448457414L;
		
		public IllegalQueryException(String msg) {
			super(msg);
		}
	}
	
	public static EconomyData getInstance() {
		return instance;
	}
}
