package net.maunium.bukkit.Mauconomy;

import java.io.IOException;
import java.util.Arrays;

import org.bukkit.plugin.ServicePriority;
import org.bukkit.plugin.java.JavaPlugin;

import net.maunium.bukkit.MauBukLib.I18n;

import net.milkbowl.vault.economy.Economy;

public class Mauconomy extends JavaPlugin {
	
	public String version, name, author, errtag, stag;
	private I18n i18n;
	private EconomyData ed;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "2[a" + name + "2]7 ";
		errtag = "4[c" + name + "4]c ";
		this.saveDefaultConfig();
		
		this.saveResource("en_US.lang", true);
		try {
			i18n = new I18n(this.getDataFolder(), this.getConfig().getString("language"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		ed = new EconomyData(this.getDataFolder());
		
		this.getCommand("mauconomy").setExecutor(new CommandMauconomy(this));
		this.getCommand("maumoney").setExecutor(new CommandMoney(this));
		this.getCommand("maumoneytop").setExecutor(new CommandMoneyTop(this));
		
		if (getConfig().getBoolean("allow-vault-bridge") && getServer().getPluginManager().getPlugin("Vault") != null) {
			getLogger().info("Loading Vault economy bridge.");
			try {
				VaultEconBridge veb = new VaultEconBridge();
				getServer().getServicesManager().register(Economy.class, veb, this, ServicePriority.Highest);
				getLogger().info("Loaded Vault economy bridge.");
			} catch (Exception e) {
				getLogger().severe("Failed to load Vault economy bridge.");
				e.printStackTrace();
			}
		} else {
			getLogger().warning("Vault not found. Not loading economy bridge.");
		}
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		
		getEconomy().close();
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	
	public String format(String s, Object... args) {
		if (i18n != null) {
			return i18n.format(s, args);
		} else {
			return s + " -- " + Arrays.toString(args);
		}
	}
	public EconomyData getEconomy(){
		return ed;
	}
}
