package net.maunium.bukkit.MauneyKills;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;

import net.milkbowl.vault.economy.Economy;
import net.milkbowl.vault.permission.Permission;

public class MauneyKills extends JavaPlugin implements Listener {
	
	private String version, name, author;
	private Economy economy = null;
	private Permission perms = null;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		this.saveDefaultConfig();
		
		RegisteredServiceProvider<Economy> economyProvider = getServer().getServicesManager().getRegistration(Economy.class);
		if (economyProvider != null) {
			economy = economyProvider.getProvider();
		}
		RegisteredServiceProvider<Permission> rsp = getServer().getServicesManager().getRegistration(Permission.class);
        perms = rsp.getProvider();
        this.getServer().getPluginManager().registerEvents(this, this);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	
	@EventHandler
	public void onPlayerDeath(PlayerDeathEvent evt) {
		Player k = evt.getEntity().getKiller();
		
		String g = perms.getPrimaryGroup(k);
		economy.depositPlayer(evt.getEntity(), getConfig().getDouble(g, 1));
		k.sendMessage("2[a" + name + "2]7 Sait " + getConfig().getDouble(g, 1) + " kun tapoit pelaajan " + evt.getEntity().getName());
	}
}
