package net.maunium.bukkit.MauntiSpam;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.UUID;
import java.util.regex.Pattern;

import org.bukkit.Bukkit;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;

public class ChatListener implements Listener {
	private MauntiSpam plugin;
	private Map<UUID, Message> messages = new HashMap<UUID, Message>();
	
	public ChatListener(MauntiSpam plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler(priority = EventPriority.LOWEST)
	public void onChat(AsyncPlayerChatEvent evt) {
		String msg = evt.getMessage();
		for (Entry<Pattern, String> e : plugin.wordReplace.entrySet())
			msg = e.getKey().matcher(msg).replaceAll(e.getValue());
		for (Pattern p : plugin.regexDeny)
			if (!evt.getPlayer().isOp() && p.matcher(msg).find()) {
				evt.setCancelled(true);
				evt.getPlayer().sendMessage(plugin.stag + plugin.translate("illegal-word"));
				return;
			}
		for (Entry<Pattern, String> e : plugin.regexRepl1.entrySet())
			if (!evt.getPlayer().isOp()) msg = e.getKey().matcher(msg).replaceAll(e.getValue());
		for (Entry<Pattern, String> e : plugin.regexRepl2.entrySet())
			if (!evt.getPlayer().isOp()) msg = e.getKey().matcher(msg).replaceAll(e.getValue());
		for (Entry<Pattern, String> e : plugin.regexRepl3.entrySet())
			if (!evt.getPlayer().isOp()) msg = e.getKey().matcher(msg).replaceAll(e.getValue());
		
		evt.setMessage(msg);
		
		if (!evt.getPlayer().hasPermission("mauntispam.mutechat.bypass")) {
			if (plugin.muted) {
				evt.setCancelled(true);
				evt.getPlayer().sendMessage(plugin.errtag + plugin.translate("mute.talk.global"));
				return;
			}
			if (plugin.mutedChat.contains(evt.getPlayer().getUniqueId())) {
				evt.getPlayer().sendMessage(plugin.errtag + plugin.translate("mute.talk.self"));
				evt.setCancelled(true);
			}
			for (UUID uuid : plugin.mutedChat)
				evt.getRecipients().remove(plugin.getServer().getPlayer(uuid));
		}
		
		if (evt.getPlayer().hasPermission("mauntispam.bypass")) return;
		Message prev = messages.get(evt.getPlayer().getUniqueId());
		Message next = new Message(msg, 0);
		if (prev != null) {
			if (!prev.isOld() && prev.equals(msg)) next = new Message(msg, prev.spamCount + 1);
			
			if (next.spamCount > 0) {
				evt.setCancelled(true);
				if (next.spamCount > 4) plugin.getServer().getScheduler().runTask(plugin, new Kicker(evt.getPlayer().getUniqueId(), plugin.translate("spamming.kick")));
				else evt.getPlayer().sendMessage(plugin.errtag + plugin.translate("spamming.warn"));
			}
		}
		
		messages.put(evt.getPlayer().getUniqueId(), next);
	}
	
	public class Kicker implements Runnable {
		private UUID player;
		private String reason;
		
		public Kicker(UUID player, String reason) {
			this.player = player;
			this.reason = reason;
		}
		
		@Override
		public void run() {
			Bukkit.getServer().getPlayer(player).kickPlayer(reason);
		}
	};
	
	public class Message {
		public final long sentAt;
		public final int spamCount;
		public final String message;
		
		public Message(String message, int spamCount) {
			this.message = message;
			this.spamCount = spamCount;
			this.sentAt = System.currentTimeMillis();
		}
		
		public boolean isOld() {
			if (System.currentTimeMillis() - sentAt > 4000) return true;
			else return false;
		}
		
		@Override
		public boolean equals(Object o) {
			if (o instanceof Message) return equals((Message) o);
			else if (o instanceof String) return equals((String) o);
			else return false;
		}
		
		public boolean equals(String s) {
			String m1 = s.toLowerCase();
			String m2 = message.toLowerCase();
			return Math.abs(m1.length() - m2.length()) < 5 && (m1.startsWith(m2) || m2.startsWith(m1));
		}
		
		public boolean equals(Message m) {
			return equals(m.message);
		}
	}
}
