package net.maunium.bukkit.MauntiSpam;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.UUID;
import java.util.regex.Pattern;

import org.bukkit.ChatColor;
import org.bukkit.plugin.java.JavaPlugin;

import net.maunium.bukkit.Maussentials.Utils.I18n;
import net.maunium.bukkit.Maussentials.Utils.I18n.I15r;

public class MauntiSpam extends JavaPlugin implements I15r {
	private I18n i18n;
	public String version;
	public boolean muted = false;
	public Set<UUID> mutedChat = new HashSet<UUID>();
	public Map<Pattern, String> wordReplace, regexRepl1, regexRepl2, regexRepl3, wordDeny;
	public List<Pattern> regexDeny;
	public final String name = "MauntiSpam", author = "Tulir293", stag = ChatColor.DARK_GREEN + "[" + ChatColor.GREEN + name + ChatColor.DARK_GREEN + "] "
			+ ChatColor.GRAY, errtag = ChatColor.DARK_RED + "[" + ChatColor.RED + name + ChatColor.DARK_RED + "] " + ChatColor.RED;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = getDescription().getVersion();
		saveDefaultConfig();
		
		reloadI18n();
		reloadSettings();
		
		getCommand("clearchat").setExecutor(new CommandClearChat(this));
		getCommand("mutechat").setExecutor(new CommandMuteChat(this));
		getCommand("mutechatglobal").setExecutor(new CommandMuteChatGlobal(this));
		getCommand("mauntispam").setExecutor(new CommandReload(this));
		getServer().getPluginManager().registerEvents(new ChatListener(this), this);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	
	public void reloadI18n() {
		saveResource("en_US.lang", true);
		saveResource("fi_FI.lang", true);
		try {
			i18n = I18n.createInstance(getDataFolder(), getConfig().getString("language"));
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
	
	public void reloadSettings() {
		reloadConfig();
		wordReplace = new HashMap<Pattern, String>();
		Map<String, Object> temp = getConfig().getConfigurationSection("word-replace").getValues(false);
		for (Entry<String, Object> e : temp.entrySet())
			wordReplace.put(Pattern.compile("(?i)" + Pattern.quote(e.getKey())),
					e.getValue().toString().replace('&', ChatColor.COLOR_CHAR).replace(ChatColor.COLOR_CHAR + "" + ChatColor.COLOR_CHAR, "&"));
		
		if (regexDeny != null) regexDeny.clear();
		else regexDeny = new ArrayList<Pattern>();
		for (String s : getConfig().getStringList("regex-deny"))
			regexDeny.add(Pattern
					.compile(s.replace('¤', '.').replace('£', ChatColor.COLOR_CHAR).replace(ChatColor.COLOR_CHAR + "" + ChatColor.COLOR_CHAR, "£")));
		
		regexRepl1 = new HashMap<Pattern, String>();
		regexRepl2 = new HashMap<Pattern, String>();
		regexRepl3 = new HashMap<Pattern, String>();
		temp = getConfig().getConfigurationSection("regex-replace").getValues(false);
		for (Entry<String, Object> e : temp.entrySet()) {
			Pattern key = Pattern.compile(e.getKey().substring(2).replace('¤', '.').replace('£', ChatColor.COLOR_CHAR)
					.replace(ChatColor.COLOR_CHAR + "" + ChatColor.COLOR_CHAR, "£"));
			String value = e.getValue().toString().replace('&', ChatColor.COLOR_CHAR).replace(ChatColor.COLOR_CHAR + "" + ChatColor.COLOR_CHAR, "&");
			if (e.getKey().startsWith("1|")) regexRepl1.put(key, value);
			else if (e.getKey().startsWith("2|")) regexRepl2.put(key, value);
			else if (e.getKey().startsWith("3|")) regexRepl3.put(key, value);
		}
	}
	
	@Override
	public String translate(String node, Object... replace) {
		return i18n.translate(node, replace);
	}
}