package net.maunium.bukkit.MauwnProtect;

import org.bukkit.entity.Arrow;
import org.bukkit.entity.Player;
import org.bukkit.entity.ThrownPotion;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;

public class DamageListener implements Listener {
	private MauwnProtect plugin;
	
	public DamageListener(MauwnProtect plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler(priority = EventPriority.LOW)
	public void onEntityDamage(EntityDamageEvent evt) {
		if (!(evt.getEntity() instanceof Player)) return;
		Player p = (Player) evt.getEntity();
		if(p.hasMetadata(plugin.PROTECT_TAG)){
			evt.setCancelled(true);
			return;
		}
		if (p.hasMetadata(plugin.TPDELAY_TAG)) {
			p.removeMetadata(plugin.TPDELAY_TAG, plugin);
			p.sendMessage(plugin.errtag + plugin.format("spawn.cancelled"));
		}
	}
	
	@EventHandler(ignoreCancelled = true)
	public void onEntityDamageByEntity(EntityDamageByEntityEvent evt){
		Player dmgr;
		if (evt.getDamager() instanceof Player) {
			dmgr = (Player) evt.getDamager();
		} else if (evt.getDamager() instanceof Arrow) {
			Arrow arr = (Arrow) evt.getDamager();
			if (arr.getShooter() instanceof Player) {
				dmgr = (Player) arr.getShooter();
			} else {
				return;
			}
		} else if (evt.getDamager() instanceof ThrownPotion) {
			ThrownPotion pot = (ThrownPotion) evt.getDamager();
			if (pot.getShooter() instanceof Player) {
				dmgr = (Player) pot.getShooter();
			} else {
				return;
			}
		} else {
			return;
		}
		if(dmgr.hasMetadata(plugin.PROTECT_TAG)){
			dmgr.removeMetadata(plugin.PROTECT_TAG, plugin);
			dmgr.sendMessage(plugin.stag + plugin.format("spawnprotect.lost"));
		}
	}
}
