package net.maunium.bukkit.OreMaunator;

import java.util.Random;

import org.bukkit.Chunk;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.generator.BlockPopulator;

public class OrePopulator extends BlockPopulator{
	OreMaunator plugin;
	public OrePopulator(OreMaunator plugin){
		super();
		this.plugin = plugin;
	}
	
	@Override
	public void populate(World w, Random r, Chunk c) {
		for (int x = 0; x < 16; x++) {
			for (int y = 0; y < 128; y++) {
				for (int z = 0; z < 16; z++) {
					Block b = c.getBlock(x, y, z);
					if (b.getType().toString().contains("ORE")) {
						b.setType(Material.STONE);
					}
				}
			}
		}
		if(r.nextInt(15) == 3){
			int x = r.nextInt(15), y = r.nextInt(10), z = r.nextInt(15);
			y += 5;
			createVein(c, r, weightedRandom(12, 4, 0.4), Material.DIAMOND_ORE, x, y, z);
		}
		
		//Change the amount range and weight of lapiz ores.
		int lapizOres = weightedRandom(2, 0, 0.7);
		//Lapiz creating loop.
		for(int i = 0; i < lapizOres; i++){
			//Randomize location.
			int x = r.nextInt(15), y = r.nextInt(25), z = r.nextInt(15);
			// Increase y by 5 so that the vein wont go too low.
			y += 5;
			//Change the size of vein;
			int sizeOfVein = weightedRandom(12, 4, 0.6);
			createVein(c, r, sizeOfVein, Material.LAPIS_ORE, x, y, z);
		}
		
		//Change the amount range and weight of redstone ores.
		int redstoneOres = weightedRandom(4, 1, 0.2);
		//Redstone creating loop.
		for(int i = 0; i < redstoneOres; i++){
			//Randomize location.
			int x = r.nextInt(15), y = r.nextInt(25), z = r.nextInt(15);
			// Increase y by 5 so that the vein wont go too low.
			y += 5;
			//Change the size of vein;
			int sizeOfVein = weightedRandom(9, 3, 0.4);
			createVein(c, r, sizeOfVein, Material.REDSTONE_ORE, x, y, z);
		}
		
		//Change the amount range and weight of gold ores.
		int goldOres = weightedRandom(4, 0, 0.4);
		//Gold creating loop.
		for(int i = 0; i < goldOres; i++){
			//Randomize location.
			int x = r.nextInt(15), y = r.nextInt(35), z = r.nextInt(15);
			// Increase y by 5 so that the vein wont go too low.
			y += 5;
			//Change the size of vein;
			int sizeOfVein = weightedRandom(10, 4, 0.6);
			createVein(c, r, sizeOfVein, Material.GOLD_ORE, x, y, z);
		}
		//Change the amount range and weight of iron ores.
		int ironOres = weightedRandom(3, 0, 0.5);
		//Iron ore creating loop.
		for(int i = 0; i < ironOres; i++){
			//Randomize location.
			int x, y, z;
			int ud = r.nextInt(5);
			if(ud < 3){
				x = r.nextInt(15);
				y = r.nextInt(25);
				z = r.nextInt(15);
				y += 25;
			} else if (ud < 5){
				x = r.nextInt(15);
				y = r.nextInt(35);
				z = r.nextInt(15);
				y += 15;
			} else {
				x = r.nextInt(15);
				y = r.nextInt(45);
				z = r.nextInt(15);
				y += 5;
			}
			//Change the size of vein;
			int sizeOfVein = weightedRandom(12, 4, 0.9);
			createVein(c, r, sizeOfVein, Material.IRON_ORE, x, y, z);
		}
		
		//Change the amount range and weight of iron ores.
		int coalOres = weightedRandom(2, 0, 0.5);
		//Iron ore creating loop.
		for(int i = 0; i < coalOres; i++){
			//Randomize location.
			int ud = r.nextInt(2);
			int x, y, z;
			if(ud < 2){
				x = r.nextInt(15);
				y = r.nextInt(25);
				z = r.nextInt(15);
				y += 35;
			} else {
				x = r.nextInt(15);
				y = r.nextInt(55);
				z = r.nextInt(15);
				y += 5;
			}
			
			//Change the size of vein
			int sizeOfVein = weightedRandom(20, 10, 1.5);
			createVein(c, r, sizeOfVein, Material.COAL_ORE, x, y, z);
		}
	}
	public void createVein(Chunk c, Random r, int size, Material m, int sx, int sy, int sz){
		int ox = sx, oy = sy, oz = sz;
		int tries = 0;
		boolean hasReset = false;
		for(int i = 0; i < size; i++){
			if(tries > 6){
				break;
			}
			if(c.getBlock(sx, sy, sz).getType().equals(Material.STONE)){
				if(r.nextInt(8) == 0 && !hasReset){
					sx = ox; sy = oy; sz = oz;
					i--;
					hasReset = true;
				} else {
					switch(r.nextInt(5)){
					case 0: c.getBlock(sx, sy, sz).setType(m); sx++;
					case 1: c.getBlock(sx, sy, sz).setType(m); sy++;
					case 2: c.getBlock(sx, sy, sz).setType(m); sz++;
					case 3: c.getBlock(sx, sy, sz).setType(m); sx--;
					case 4: c.getBlock(sx, sy, sz).setType(m); sy--;
					case 5: c.getBlock(sx, sy, sz).setType(m); sz--;
					}
					tries = 0;
					hasReset = false;
				}
			} else {
				i--;
				tries++;
				switch(r.nextInt(4)){
				case 0: sx++;
				case 1: sz++;
				case 2: sx--;
				case 4: sz--;
				}
			}
		}
	}
	public int weightedRandom(int max, int min, double weight) {
		int rand = (int) Math.floor(Math.random() * max + min);
		if (Math.random() >= weight) {
			++rand;
		}
		return rand;
	}
}
