package net.maunium.bukkit.PlayerLauncher;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class LauncherCommand implements CommandExecutor{
	PlayerLauncher plugin;
	public LauncherCommand(PlayerLauncher plugin){
		this.plugin = plugin;
	}
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args){
		if(!(sender instanceof Player)){
			sender.sendMessage(plugin.errtag + "Can only be run as a player.");
			return true;
		}
		Player p = (Player) sender;
		if(sender.hasPermission("playerlauncher.admin") || sender.isOp()){
			if (args.length == 1){
				if(args[0].equalsIgnoreCase("creator")){
					ItemStack is = new ItemStack(Material.STICK, 1);
					ItemMeta im = is.getItemMeta();
					im.setDisplayName("blPlayerLauncher Creator");
					List<String> l = new ArrayList<String>();
					l.add("4lNot initialized");
					im.setLore(l);
					is.setItemMeta(im);
					p.getInventory().addItem(is);
					return true;
				} else if (args[0].equalsIgnoreCase("remover")){
					ItemStack is = new ItemStack(Material.BLAZE_ROD, 1);
					ItemMeta im = is.getItemMeta();
					im.setDisplayName("blPlayerLauncher Remover");
					List<String> l = new ArrayList<String>();
					l.add("aReady to remove!");
					l.add(" ");
					im.setLore(l);
					is.setItemMeta(im);
					p.getInventory().addItem(is);
					return true;
				} else if (args[0].equalsIgnoreCase("inspector")){
					ItemStack is = new ItemStack(Material.FEATHER, 1);
					ItemMeta im = is.getItemMeta();
					im.setDisplayName("blPlayerLauncher Inspector");
					List<String> l = new ArrayList<String>();
					l.add("aReady to inspect!");
					l.add(" ");
					im.setLore(l);
					is.setItemMeta(im);
					p.getInventory().addItem(is);
					return true;
				} else if (args[0].equalsIgnoreCase("reload")){
					p.sendMessage(plugin.stag + "Reloading launchers... This function has not been tested fully. Errors may occur.");
					long st = System.currentTimeMillis();
					for(Location l : plugin.launchers){
						l.getBlock().removeMetadata("isLauncher", plugin);
					}
					plugin.cm.loadConfig();
					long et = st - System.currentTimeMillis();
					p.sendMessage(plugin.stag + "Reloading complete in " + et + "ms.");
				}
			} else if (args.length == 4){
				if(args[0].equalsIgnoreCase("initialize")){
					double x, y, z;
					try{
						x = Double.parseDouble(args[1]);
						y = Double.parseDouble(args[2]);
						z = Double.parseDouble(args[3]);
					} catch (Exception e){
						p.sendMessage(plugin.errtag + "The three last arguments must be doubles!");
						return true;
					}
					if(p.getItemInHand().getType().equals(Material.STICK)){
						if(p.getItemInHand().hasItemMeta()){
							if(p.getItemInHand().getItemMeta().hasLore() && p.getItemInHand().getItemMeta().hasDisplayName()){
								if(p.getItemInHand().getItemMeta().getDisplayName().equals("blPlayerLauncher Creator")){
									List<String> lore = new ArrayList<String>();
									lore.add("aReady to create!");
									lore.add(x + ", " + y + ", " + z);
									ItemMeta im = p.getItemInHand().getItemMeta();
									im.setLore(lore);
									p.getItemInHand().setItemMeta(im);
								} else {
									p.sendMessage(plugin.errtag + "You don't have a PlayerLauncher creator in your hand!");
								}
							} else {
								p.sendMessage(plugin.errtag + "You don't have a PlayerLauncher creator in your hand!");
							}
						} else {
							p.sendMessage(plugin.errtag + "You don't have a PlayerLauncher creator in your hand!");
						}
					} else {
						p.sendMessage(plugin.errtag + "You don't have a PlayerLauncher creator in your hand!");
					}
					return true;
				}
			}
		}
		return false;
	}
}
