package net.maunium.bukkit.PlayerLauncher;

import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.metadata.FixedMetadataValue;

public class PlayerInteractListener implements Listener {
	PlayerLauncher plugin;
	
	public PlayerInteractListener(PlayerLauncher plugin) {
		this.plugin = plugin;
	}
	
	@EventHandler
	public void onInteract(PlayerInteractEvent evt) {
		if (!evt.getAction().equals(Action.RIGHT_CLICK_BLOCK)) return;
		if (evt.getItem() == null) return;
		if (!evt.getItem().hasItemMeta()) return;
		if (!evt.getItem().getItemMeta().hasLore()) return;
		if (!evt.getItem().getItemMeta().hasDisplayName()) return;
		if (evt.getItem().getItemMeta().getLore().contains("4lNot initialized")) return;
		
		if (evt.getItem().getItemMeta().getDisplayName().equals("blPlayerLauncher Creator") || evt.getItem().getType().equals(Material.STICK)) {
			String s = evt.getItem().getItemMeta().getLore().get(1);
			String[] temp = s.split(", ");
			if (temp.length != 3) { return; }
			double x, y, z;
			try {
				x = Double.parseDouble(temp[0]);
				y = Double.parseDouble(temp[1]);
				z = Double.parseDouble(temp[2]);
			} catch (Exception e) {
				return;
			}
			Block b = evt.getClickedBlock();
			if (b.hasMetadata("isLauncher")) evt.getPlayer().sendMessage(plugin.stag + "(Re-)Created, vector: " + x + ", " + y + ", " + z);
			else evt.getPlayer().sendMessage(plugin.stag + "Created, vector: " + x + ", " + y + ", " + z);
			
			b.setMetadata("isLauncher", new FixedMetadataValue(plugin, true));
			plugin.launchers.add(b.getLocation());
			plugin.setBlockMetadata("launcher-x", x, b);
			plugin.setBlockMetadata("launcher-y", y, b);
			plugin.setBlockMetadata("launcher-z", z, b);
		} else if (evt.getItem().getItemMeta().getDisplayName().equals("blPlayerLauncher Remover") && evt.getItem().getType().equals(Material.BLAZE_ROD)) {
			Block b = evt.getClickedBlock();
			if (b.hasMetadata("isLauncher")) {
				b.removeMetadata("isLauncher", plugin);
				plugin.launchers.remove(b.getLocation());
				evt.getPlayer().sendMessage(plugin.stag + "The block is no longer a launcher.");
			} else evt.getPlayer().sendMessage(plugin.errtag + "That block is not a launcher.");
		} else if (evt.getItem().getItemMeta().getDisplayName().equals("blPlayerLauncher Inspector") && evt.getItem().getType().equals(Material.FEATHER)) {
			Block b = evt.getClickedBlock();
			if (b.hasMetadata("isLauncher")) {
				evt.getPlayer().sendMessage(
						"7Vector " + plugin.getBlockMetadata("launcher-x", b) + ", " + plugin.getBlockMetadata("launcher-y", b) + ", " + plugin.getBlockMetadata("launcher-z", b) + " - Location "
								+ b.getLocation().getBlockX() + ", " + b.getLocation().getBlockY() + ", " + b.getLocation().getBlockZ() + " @ " + b.getWorld().getName());
			} else evt.getPlayer().sendMessage(plugin.errtag + "That block is not a launcher.");
		}
	}
}
